package conv

import (
	"encoding/json"
	"gadmin/package/gmdata"
	"gadmin/utility"
	"github.com/sirupsen/logrus"
)

var Antique = new(cAntique)

type cAntique struct {
	version string
	lst     []*gmdata.Antique
}

func (j *cAntique) Extract(version string) {
	logrus.Info("cAntique Extract...")
	j.setVersion(version).convert().save()
}

func (j *cAntique) setVersion(version string) *cAntique {
	j.version = version
	return j
}

func (j *cAntique) convert() *cAntique {
	b, err := GetUrlBody(j.version, "antique.json")
	if err != nil {
		logrus.Fatalf("GetUrlBody err:%+v", err)
	}

	if err := json.Unmarshal(b, &j.lst); err != nil {
		logrus.Fatalf("err=%v", err)
	}

	return j
}

func (j *cAntique) save() {
	filePath := utility.LocalJsonPath(j.version, "antique.json")
	SaveJsonPath(filePath, j.lst)
}
